"Dialog editing roles."


#
#   MoviePaca, movie database manager.
#   Copyright (C) 2010  Joakim Soderlund
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


import os
import gtk

import util


class DiaRole():
	def __init__(self, role_id, callback=None):
		self.builder = gtk.Builder()
		self.builder.add_from_file(os.path.join(util.DATA_PATH, "glade", "role.glade"))
		self.builder.connect_signals(self)
		self.dialog = self.builder.get_object("dia_role")
		
		self.role_id = role_id
		self.callback = callback
		
		# Basic information
		self.lab_id = self.builder.get_object("lab_id")
		self.ent_role = self.builder.get_object("ent_role")
		
		cursor = util.create_cursor()
		if cursor.execute("SELECT role FROM Role WHERE role_id = %s", role_id) != 1:
			raise Exception("Invalid role id!")
		
		role = cursor.fetchone()[0]
		
		self.lab_id.set_text(str(role_id))
		self.ent_role.set_text(role)
		
	def role_apply(self, *args):
		query = """
			UPDATE Role
			SET role = %s
			WHERE role_id = %s
		"""
		
		data = [
			self.ent_role.get_text(),
			str(self.role_id),
		]
		
		cursor = util.create_cursor()
		cursor.execute(query, data)
		cursor.close()
		
		if callable(self.callback):
			self.callback()
		
		self.dialog.destroy()

