"Helpers for loading data, populating lists, creating items etc."


#
#   MoviePaca, movie database manager.
#   Copyright (C) 2010  Joakim Soderlund
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


import os
import MySQLdb


def _get_data_path():
	for path in SEARCH_PATHS:
		if os.path.isfile(os.path.join(path, SEARCH_FILE)):
			return path

def create_cursor():
	return DB_CONNECTION.cursor()

def update_liststore(liststore, query, data=None):
	cursor = create_cursor()
	cursor.execute(query, data)
	liststore.clear()
	for row in cursor:
		liststore.append(row);
	cursor.close()

SEARCH_FILE = os.path.join("glade", "main.glade")

SEARCH_PATHS = (
		".",
		"/usr/local/share/moviepaca",
		"/usr/share/moviepaca",
)

DATA_PATH = _get_data_path()

DB_SETUP = {
	"host" : "localhost",
	"user" : "root",
	"passwd" : "p4zzw0rd",
	"db" : "movie_toy",
	"use_unicode" : True,
	"charset" : "utf8"
}

DB_CONNECTION = MySQLdb.connect(**DB_SETUP)
